import com.nttdocomo.ui.*;
import java.io.*;
import javax.microedition.io.Connector;

// iAv璅MfBpnh
// 4`lPSG[ČNXłB
// `lƂ̎gijAʁAFw肵
// bԕ\60MLDV[PXo͂܂B
// ̃NX[h
// AudioPresenter.getAudioPresenter()
// ɂ2̃I[fBI`lStaticɃoCh܂B
//
// t[idoFramesɁjɖ1/60bMLDV[PXo͂܂B
// o̓t[w肵ƎIɍĐJn܂B
// (nhŕbԃt[s60ɐƂȂ߂炩ɍĐ܂B)
//
//
// ͓͎g炨悻̉Zoďo͂܂B
// ܂̓mCYpɉ𒼐ڎw肷郂[hpӂĂA
// g̑ɏo͂鉹𒼐ڎw肷邱Ƃ\łB
// (҂̏ꍇA 0 ` 86(0 = A55Hz) 12KŎw肵܂B)
//
// ʂ0-63w肵܂BȊOł͒l̉6bit̂ݎQƂ܂B
//
// FGMF܂͌q̓[p[h̉F
// 16̃oNɔCӂ̉F蓖Ă邱Ƃo܂B
// ۂ̉F́A蓖ĂꂽF̒oNԍw肵đI܂B
//
// oNɊ蓖Ă鉹Fԍ0-127GMFԍw肵܂B
// ȊOł͒l̉7bit̂ݎQƂ܂B
//
// ܂AN505i, P902ip̉F[hw肷邱ƂoA
// iN[hAP[hBj
// e[hPSGɎF𗘗p\łB
// N[hAP[hGMFԍ0-4ɂꂼ
// 12.5%A25%A50%`gAOpgAmCY
// ɋ߂}bv܂
// N[hAP[h͎w肵Fԍ̂A6bit(0-63)݂̂QƂ܂B
//
// SO,SH902-903̏ꍇA̉ʕύX({[Gx[v)
// dlAɍČ܂B
// P[hgṕA̐Aɓr؂ꂪ܂B
//
// XeI[hLɂꍇA
// o͉͍E2ch̃XeIp|bglw\łB
// e`l̃p|bgl0-63w肵܂B
// ȊOł͒l̉6bit̂ݎQƂ܂B
 
public class PSGi {
	static final int MODE_PRESET = 0;
	static final int MODE_YAMAHA = 1;
	static final int MODE_ROHM = 2;

	static final int NUM_OF_TRACKS = 4;		//4chȏ͖ʓ|̂łȂcB
	static final int NUM_OF_TONEBANK = 16;	//16F炢Α̂Ⴀ܂B
	
	private static final int SIZE_OF_OUTBUF = 5120;	//1t[ő80byte * 60 +

	private static final int PITCH_LIST[] = { 1812,1919,2033,2154,2282,2418,2562,2714,2876,3047,3228,3420 };
	private static final int PITCHRANGE_LOWER = 1710;
	private static final int PITCHRANGE_HIGHER = 3420;

	private static final int MLD_NOTE_VELOCITY = 63 << 2;
	private static final int MLD_NOTE_DURATION = 3;
	private static final int MLD_NOTERANGE_MAX = 62;
	private static final int MLD_NOTERANGE_MIN = 0;
	private static final int MLD_OCTSHIFT_NONE = 0x00;
	private static final int MLD_OCTSHIFT_UP = 0x01;
	private static final int MLD_OCTSHIFT_DOWN2 = 0x02;
	private static final int MLD_OCTSHIFT_DOWN = 0x03;		
	private static final int NOTENUM_SILENT = 75;		
	private static final int NOTE_RANGE_MAX = 86;
	private static final int NOTE_RANGE_MIN = 0;
	
	private static final byte MLDSEQ_NOP[] =  { 
			(byte)MLD_NOTE_DURATION,
			(byte)0xFF,
			(byte)0xDE,
			(byte)0x00
	};
	
	private static final byte MLDSEQ_EOT[] = {
			(byte)(MLD_NOTE_DURATION + 1),
			(byte)0xFF,
			(byte)0xDF,
			(byte)0x00,
	};
	
	//Đsetsound()oȂ̂łQp
	static private final AudioPresenter ap0 = AudioPresenter.getAudioPresenter();
	static private final AudioPresenter ap1 = AudioPresenter.getAudioPresenter();
	
	private AudioPresenter ap;
	private byte[] mldHeader;
	private byte[] trackHeader;
	private byte[] mldOutBuf;	
	private int mldOutCnt;	
	private int frameCount;	
	
	//ݒ蓙
	private int frameBufCount;
	private int soundMode;
	private boolean soundEnable;
	private boolean chEnable[] = new boolean[NUM_OF_TRACKS];
	private boolean soundStereo;
	private int toneBank[] = new int[NUM_OF_TONEBANK];
	
	private boolean chNoiseMode[] = new boolean[NUM_OF_TRACKS];
	private int chNoteNum[] = new int[NUM_OF_TRACKS];
	private int chOctShift[] = new int[NUM_OF_TRACKS];
	private int chTone[] = new int[NUM_OF_TRACKS];
	private int chVolume[] = new int[NUM_OF_TRACKS];
	private int chPan[] = new int[NUM_OF_TRACKS];
	

	PSGi() {
		ap = ap0;
		mldHeader = loadLocalResouce("resource:///mldheader.mld");
	}
	
	void setFrameBufCount(int count) {
		if(count > 60 || count < 0) return;
		frameBufCount = count;
	}

	void setToneBank(int bank, int tone) {
		if(bank >= NUM_OF_TONEBANK || bank < 0) return;
		toneBank[bank] = tone;
	}
	
	void setMode(int mode) {
		switch(mode) {
		case MODE_PRESET:
			trackHeader = loadLocalResouce("resource:///trackheader_preset.mld");
			soundMode = mode;
			break;
		case MODE_YAMAHA:
			trackHeader = loadLocalResouce("resource:///trackheader_n.mld");
			soundMode = mode;
			break;
		case MODE_ROHM:
			trackHeader = loadLocalResouce("resource:///trackheader_p.mld");
			soundMode = mode;
			break;
		}
	}
	
	void setSoundEnable(boolean enable) {
		soundEnable = enable;
	}
	
	void setSoundStereo(boolean enable) {
		soundStereo = enable;
	}
	
	void setMasterVolume(int vol) {
		if(vol > 100 | vol < 0) return;
		ap0.setAttribute(AudioPresenter.SET_VOLUME, vol);
		ap1.setAttribute(AudioPresenter.SET_VOLUME, vol);
	}
	
	void setChEnable(int ch , boolean enable) {
		if(ch >= chEnable.length | ch < 0) return;
		chEnable[ch] = enable;
	}		
	
	void setChVolume(int ch, int vol) {
		if(ch >= NUM_OF_TRACKS || ch < 0) return;
		chVolume[ch] = vol;
	}
	
	void setChPan(int ch, int val) {
		if(ch >= NUM_OF_TRACKS || ch < 0) return;
		chPan[ch] = val;
	}
	
	void setChFreq(int ch, int freq) {
		if(ch >= NUM_OF_TRACKS || ch < 0) return;
		
		//m[giovZ
		if(chNoiseMode[ch]) {
			if(freq > NOTE_RANGE_MAX || freq < NOTE_RANGE_MIN)
				chNoteNum[ch] = NOTENUM_SILENT;
			else
				chNoteNum[ch] = freq - 12;
		}
		else {
			chNoteNum[ch] = freqToNotenum(freq);
		}

		//IN^[uVtg
		if(chNoteNum[ch] < MLD_NOTERANGE_MIN) {
			chNoteNum[ch] += 12;
			chOctShift[ch] = MLD_OCTSHIFT_DOWN;
		} else if(chNoteNum[ch]  > MLD_NOTERANGE_MAX) {
			chNoteNum[ch] -= 12;
			chOctShift[ch] = MLD_OCTSHIFT_UP;
		} else {
			chOctShift[ch] = MLD_OCTSHIFT_NONE;
		}
	}
	
	void setChTone(int ch, int bank) {
		if(ch >= NUM_OF_TRACKS || ch < 0) return;
		chTone[ch] = bank;
	}
	
	void setChNoiseMode(int ch, boolean flag) {
		if(ch >= NUM_OF_TRACKS || ch < 0) return;
		chNoiseMode[ch] = flag;
	}
	
	void doFrame() {
		if(!soundEnable) return;
		
		outFrameSeq();
		frameCount++;
		
		//t[o͂Đ
		if(frameCount >= frameBufCount) {
			playMld(getMld());
			frameCount = 0;
		}
	}
	
	private void playMld(byte[] mld) {
		MediaSound mso;
		
		//AP؂ւ(P902i1chłB
		if(soundMode != MODE_ROHM) {
			if(ap == ap0) {
				ap = ap1;
			} else {
				ap = ap0;
			}
		}
		
		mso = MediaManager.getSound(mld);

		try {
			mso.use();
			ap.stop();
		} catch (Exception e) {
//			System.out.println(e.toString());
		} 

		ap.setSound(mso);
		ap.play();
	}
	
	private byte[] getMld() {
		int tracksize; 
		byte[] ret;
		
		//EOTǉ
		for(int i=0; i < MLDSEQ_EOT.length; i++) 
			mldOutBuf[mldOutCnt++] = MLDSEQ_EOT[i];
		
		//tracTCY
		tracksize = mldOutCnt - mldHeader.length - 8;
		mldOutBuf[mldHeader.length + 4] = (byte)(tracksize >> 24);
		mldOutBuf[mldHeader.length + 5] = (byte)(tracksize >> 16);
		mldOutBuf[mldHeader.length + 6] = (byte)(tracksize >> 8);
		mldOutBuf[mldHeader.length + 7] = (byte)(tracksize >> 0);

		//MLDTCY
		mldOutBuf[4] = (byte)(mldOutCnt - 8 >> 24); 
		mldOutBuf[5] = (byte)(mldOutCnt - 8 >> 16); 
		mldOutBuf[6] = (byte)(mldOutCnt - 8 >> 8); 
		mldOutBuf[7] = (byte)(mldOutCnt - 8 >> 0); 
		
		ret = mldOutBuf;
		mldOutBuf = null;
		
		return ret;
	}

	private void outFrameSeq() {
		int seqsize = 12;
		int datasize = 0;
		int chCode;
		
		boolean chOutput[] = new boolean[NUM_OF_TRACKS];
		
		//ȂMLDobt@(wb_Ƃ
		if(mldOutBuf == null) {
			mldOutBuf = new byte[SIZE_OF_OUTBUF];
			System.arraycopy(mldHeader, 0, mldOutBuf, 0, mldHeader.length);
			System.arraycopy(trackHeader, 0, mldOutBuf, mldHeader.length, trackHeader.length);
			mldOutCnt = mldHeader.length + trackHeader.length;
		}
		
		//t[̏o̓f[^TCYvZ
		if(soundStereo) seqsize += 4;
		if(soundMode == MODE_PRESET) seqsize += 4;
		
		for(int i=0 ; i < NUM_OF_TRACKS; i++) {
			if(chEnable[i] && chVolume[i] > 0) {
				datasize += seqsize;
				chOutput[i] = true;
			}
		}
		
		//t[ȂNOPV[PXo
		if(datasize == 0) { 
			for(int i=0; i < MLDSEQ_NOP.length; i++) 
				mldOutBuf[mldOutCnt++] = MLDSEQ_NOP[i];
			return;
		}
		
		//o
		for(int i=0; i < NUM_OF_TRACKS; i++) {
			chCode = i << 6;
			if(!chOutput[i]) continue;
			
			
			//vZbĝƂoNZNgo
			if(soundMode == MODE_PRESET) {
				mldOutBuf[mldOutCnt++] = (byte)0x00;
				mldOutBuf[mldOutCnt++] = (byte)0xFF;
				mldOutBuf[mldOutCnt++] = (byte)0xE1;
				mldOutBuf[mldOutCnt++] = (byte)(chCode | 0x02 | toneBank[chTone[i]] >> 6 & 0x01);
			}
			
			//XeI
			if(soundStereo) {
				mldOutBuf[mldOutCnt++] = (byte)0x00;
				mldOutBuf[mldOutCnt++] = (byte)0xFF;
				mldOutBuf[mldOutCnt++] = (byte)0xE3;
				mldOutBuf[mldOutCnt++] = (byte)(chCode | chPan[i] & 0x3F);
			}
			
			mldOutBuf[mldOutCnt++] = (byte)0x00;
			mldOutBuf[mldOutCnt++] = (byte)0xFF;
			mldOutBuf[mldOutCnt++] = (byte)0xE0;
			mldOutBuf[mldOutCnt++] = (byte)(chCode | toneBank[chTone[i]] & 0x3F);		
			mldOutBuf[mldOutCnt++] = (byte)0x00;
			mldOutBuf[mldOutCnt++] = (byte)0xFF;
			mldOutBuf[mldOutCnt++] = (byte)0xE2;
			mldOutBuf[mldOutCnt++] = (byte)(chCode | chVolume[i] & 0x3F);
			mldOutBuf[mldOutCnt++] = (byte)0x00;									
			mldOutBuf[mldOutCnt++] = (byte)(chCode | chNoteNum[i] & 0x3F);	
			mldOutBuf[mldOutCnt++] = (byte)(MLD_NOTE_DURATION + 1);
			mldOutBuf[mldOutCnt++] = (byte)(MLD_NOTE_VELOCITY | chOctShift[i] & 0x03);
		}

		//t[̐擪f[^^C炷
		mldOutBuf[mldOutCnt - datasize] = (byte)MLD_NOTE_DURATION;	
	}
	
	private int freqToNotenum(int freq) {
		//g特No.ɕϊB(V˓I_C^CcB
		//(Ԃl) -12 `74
		int noteNum = 0;
		int steps = 0;
		
		if(freq == 0) return NOTENUM_SILENT;

		if(freq < PITCHRANGE_LOWER) { 
			while(freq < PITCHRANGE_LOWER) {
				freq *= 2;
				steps++;
			}
		}
		else if(freq > PITCHRANGE_HIGHER) {
			while(freq > PITCHRANGE_HIGHER) {
				freq /= 2;
				steps--;
			}
		}

		for(int i=0;i<12;i++) {
			if(freq < PITCH_LIST[i]) {
				noteNum = i + 12 * (4 - steps);
				break;
			}
		}
		
		//Đs\
		if(noteNum < -12 || noteNum > 74) noteNum = NOTENUM_SILENT;
		
		return noteNum;
	}	
	
	private byte[] loadLocalResouce (String location) {
		int datasize = 0;
		byte[] buf = new byte[2048];
		byte[] data;

		try {
			InputStream is = Connector.openDataInputStream(location);
			datasize = is.read(buf);
			is.close();
		}
		catch (IOException e){
			System.out.println("loadLocalResouce:"+e.toString());
		}

		data = new byte[datasize];
		System.arraycopy(buf, 0, data, 0, data.length);
		return data;
	}
}


	